
#include	"pltutl.hpp"

//static const char  *SCCSID	 = " %Z% SCCS ID INFO: ** %M% %E% Ver.:%R%.%L%** ";

const long max_buf=256;
/** Color Line 
 * iicol: Initial color index 
 * ifcol: Final color index
 * carr[]: Character for sample, or sequential number in case of 0.
 */
void Color_Line_Sample(int iicol,  int ifcol, 
		       const float xoff, const float yoff,
		       char *carr[]){
  cpgswin(0., 1.0, 0., 1.0);
  float cheight;
  int ci, lw;
  cpgqci(&ci);
  cpgqlw(&lw);
  cpgqch(&cheight);
  cpgsch(2.0);
  cpgslw(3);
  cpgsclp(0);
  float dy = cheight *0.05;
  float y0 = 0.05 + yoff;
  char lab[20];
  int cnt=0;
  for(int i=iicol; i<=ifcol; i++){
    float y1 = y0 + dy *i;
    float x1 = 0. + xoff, 
      x2 = 0.5 + xoff, 
      x3 = 0.8 + xoff;
    if( carr ==0)
      sprintf(lab, "%2d ", i);
    else
      sprintf(lab, "%s ", carr[cnt++]);
    
    cpgsci(i);
    cpgptxt(x1,y1,0, 0, lab);
    cpgmove(x2, y1);
    cpgdraw(x3, y1);
  }
  cpgsci(ci);
  cpgslw(lw);
  cpgsch(cheight);
  cpgsclp(1);
}

float	Plt_inf::Tickcal(float tick)
  ///*float tick; */
{

 double indx, work, fact;
 float	ret;

   work = tick;
   indx = log10(work);
   indx = floor(indx);
   fact = pow(10., indx);
   work = floor(work / fact)*fact;
   ret = work;
   return(ret);
}

void Plt_inf::Dev_name(std::string dev  )
{
  
  if( dev.length() ==0)  Read_Parfile();
  else  device_name =  dev;

  if ( cpgopen(device_name.c_str()) != 1){
    fprintf(stderr, "Cannot start pgopen \n");
    exit(EXIT_FAILURE); 
  }
 
}

void Plt_inf::Read_Parfile( void )
{
  char*	buf = new char [max_buf];
  char  filename[80];
  FILE	*fp_par;
  char	*p_env, *token;
  const char *sep = " \t\n";

  /**** Config Paramete file open ***/
  if( (p_env = getenv("TEMP")) != NULL) strcpy( filename, p_env);
  else					 strcpy( filename, "/tmp");
  strcat( filename, "/PAR_FILE" );
  if( (fp_par = fopen( filename , "r") )== NULL){
    printf(" Config. Parameter FILE: %s, can't be opened \n", filename);
    printf(" --------------------------\n");
    if((fp_par = fopen( filename,  "a+")) == NULL){
      printf(" Cannot Create %s file\n", filename);
      exit(EXIT_FAILURE);
    }
    fprintf(fp_par,"! *** PG PLOT OUT Device***\n");
    fprintf(fp_par,"PGOUT  /xwindow\n");
    fflush(fp_par);
    rewind(fp_par);
    printf(" Warning!!\n");
    printf("  Parameter FILE: %s is Cleated! in Append mode\n", filename);
  }
  
  while( fgets(buf, max_buf, fp_par) != NULL){
    if( buf[0] == '!') continue;
    token = strtok(buf, sep);
    if ( strncmp(token, "PGOUT", 5) != 0)continue;
    else{ 
      if((token = strtok(NULL, sep)) ==NULL){
	fprintf(stderr, "Error: %s format is wrong \n", filename);
	exit(EXIT_FAILURE);
      }
      device_name= token;
      fprintf(stdout, " Device Name = %s\n", device_name.c_str());
      break;
    }
  }
  fclose(fp_par);
}

void Plt_inf::Plot1(const long ndat, const float* xarr, 
		    const float* yarr, const float *yerr)
{
  char	 xopt_l[40], yopt_l[40];
  float	 xmin, xmax, ymax, ymin, range;
  
  ndata = ndat;
  //  this->xarr = xarr;
  // this->farr = yarr;

  
  if( (flag2 & XOPT_FORCE) == XOPT_FORCE)
    strcpy(xopt_l, this->xopt);
  else{
    strcpy(xopt_l, "BCNTS");
    if( strlen(this->xopt) !=0) strcat(xopt_l, this->xopt);
  }
  if( (flag2 & YOPT_FORCE) == YOPT_FORCE)
    strcpy(yopt_l, this->yopt);
  else{
    strcpy(yopt_l, "BCNTS");
    if( strlen(this->yopt) !=0) strcat(yopt_l, this->yopt);
  }
  if( strlen(this->opt) !=0) strcat(yopt_l, this->opt);

  Maxmin_db <float> maxmin_db;
  maxmin_db.Max_min1(yarr,ndata);
  ymax = maxmin_db.Max();
  ymin = maxmin_db.Min();
  range = ymax - ymin;
  if( ymax == ymin){
    ymax += 0.05;
    ymin -=0.05;
  }
  ymax += 0.1*range;
  ymin -= 0.1*range;
  
  if( flag & YMIN_FORCE) ymin = this->ymin;
  if( flag & YMAX_FORCE) ymax = this->ymax;
  range=ymax - ymin;
  if ( fabs(range) < 1.e-30 ){
    if( fabsf(ymax) < 1.e-30) {
      fprintf(stderr, "Error: ymax == ymin ==0\n");
      return;
    }else { 
      ymax *= 1.1;
    }
  }
  if( (flag & YMIN_FORCE) != YMIN_FORCE) ymin -= range*0.1; 
  if( (flag & YMAX_FORCE) != YMAX_FORCE) ymax += range*0.1;
  //  printf("ymin, ymax = %g, %g\n", ymin, ymax);
  fmax = ymax;
  fmin = ymin;
  
  maxmin_db.Max_min1(xarr,ndata);
  if( (flag & XMAX_FORCE) == XMAX_FORCE)
    xmax = this->xmax;
  else
    xmax = maxmin_db.Max();
  if( (flag & XMIN_FORCE) == XMIN_FORCE)
    xmin = this->xmin;
  else
    xmin = maxmin_db.Min();
  if( fabsf(xmax - xmin) < 1.e-30 ){ 
    if( fabs(xmax) < 1.e-30){
      fprintf(stderr, "Error: xmax == xmin ==0\n");
      return;
    }else{  
      xmax *= 1.1;
    }
  }
  range=xmax - xmin;
  if( (flag & XMIN_FORCE) != XMIN_FORCE) xmin -= range*0.1; 
  if( (flag & XMAX_FORCE) != XMAX_FORCE) xmax += range*0.1;
  
  if( (flag & XTICK_FORCE) ==0) {
    xtick= Tickcal((xmax - xmin)/3.5);
    if(strchr(xopt_l,'H') !=0){// Time axis 
      xtick = (xtick < 300) ? (xtick/300 < 0.5 ? xtick : 300) 
	: (xtick < 600 ? (xtick/600 < 0.5 ? 300 : 600)
	   : (xtick < 1200 ? (xtick/1200 < 0.5 ? 600 : 1200)
	      : (xtick < 1800 ? (xtick/1800 < 0.5 ? 1200 : 1800)
		 : (xtick < 3600 ? (xtick/3600 < 0.5 ? 1800 : 3600)
		    : (xtick < 7200 ? (xtick/7200 < 0.5 ? 3600 : 7200)
		       : (xtick < 10800 ? (xtick/10800 < 0.5 ? 7200 : 10800)
			  : (xtick < 14400 ? (xtick/14400 < 0.5 ? 10800 : 14400)
			     : (xtick < 18000 ? (xtick/18000 < 0.5 ? 14400 : 18000)
				: xtick))))))));
    }
  }
  if( (flag & YTICK_FORCE) ==0) 
    ytick= Tickcal((ymax - ymin)/3.5);
  
  // cpgsvp(0.2,0.8,0.2,0.8);
  cpgslw(lwidth);
  cpgsch(cheight);
  int icol2;
  cpgqci(&icol2);
  cpgsci(icol);

  if( flag2 & XYSAME_ASPCT)
    cpgwnad(xmin, xmax, ymin, ymax);
  else
    cpgswin(xmin, xmax, ymin, ymax);
  cpgtbox(xopt_l, xtick, 2, yopt_l, ytick, 2);
  if( strlen(title) != 0)    
    cpgmtxt("T", lbl_pos[0][0], lbl_pos[0][1], lbl_pos[0][2], title);
  if( strlen(xlabel) != 0)
    cpgmtxt("B", lbl_pos[1][0], lbl_pos[1][1], lbl_pos[1][2], xlabel);
  if( strlen(ylabel) != 0)  
    cpgmtxt("L", lbl_pos[2][0], lbl_pos[2][1], lbl_pos[2][2], ylabel);

  Oplot1(ndat,xarr,yarr, yerr);
  cpgsci(icol2);
}

void Plt_inf::Oplot1(const long ndat, const float* x, const float* y,
		     const float *yerr)
{
  int icol2;

  cpgslw(lwidth);
  cpgqci(&icol2);
  cpgsci(icol);
  if( flag & PLOT_MODE)
    cpgpt(ndat, x, y, lptype);
  else{
    int ils2;
    cpgqls(&ils2);
    cpgsls(ils);
    cpgline(ndat, x, y);
    cpgsls(ils2);
  }
  if(yerr !=NULL)
    cpgerrb(6, ndat, x, y, yerr, 1);
  cpgsci(icol2);
  
}

void Plt_inf::Plot1(const long ndat, const double* x, const double* y,
		    const float* yerr){
  
  float* xa = new float [ndat];
  float* ya = new float [ndat];
  int i;
  for(i=0; i<ndat; i++){
    xa[i] = x[i];
    ya[i] = y[i];
  }
  Plot1(ndat,xa,ya, yerr); 	
  delete [] xa;
  delete [] ya;
}

void Plt_inf::Oplot1(const long ndat, const double* x, 
		     const double* y, const float* yerr)
{
  
  valarray <float> xa(ndat);
  valarray <float> ya(ndat);

  int i;
  for(i=0; i<ndat; i++){
    xa[i] = x[i];
    ya[i] = y[i];
  }

  Oplot1(ndat,&xa[0],&ya[0], yerr);
  
}

void Plt_inf::Plot2d(const float *xarr, const float *yarr, const float *farr, 
		     int nx, int ny)
{
  
  Maxmin_db <float> maxmin_db;
  int32_t c1, c2, nc;
  float   tr[6];
  
  float dx = xarr[1] - xarr[0];
  float dx2 = yarr[1] - yarr[0];

  maxmin_db.Max_min2(farr, nx, ny);
  ixmax = maxmin_db.Imax();
  iymax = maxmin_db.Jmax();
  fmax = maxmin_db.Max();
  fmin = maxmin_db.Min();
  if( fmax == fmin){
    fmax +=0.05;
    fmin -=0.05;
  }
  
  maxmin_db.Max_min1(xarr, nx);
  float xmax0 = maxmin_db.Max();
  float xmin0 = maxmin_db.Min();
  float xmax, xmin;
  if(flag & XMAX_FORCE) xmax = this->xmax; else xmax = xmax0;
  if(flag & XMIN_FORCE) xmin = this->xmin; else xmin = xmin0;
  if( xmax == xmin){
    xmax +=0.05;
    xmin -=0.05;
  }
  
  maxmin_db.Max_min1(yarr,ny);
  float x2max0 = maxmin_db.Max();
  float x2min0 = maxmin_db.Min();
  float x2max, x2min;
  if(flag & X2MAX_FORCE) x2max = this->x2max; else x2max = x2max0;
  if(flag & X2MIN_FORCE) x2min = this->x2min; else x2min = x2min0;
  if( x2max == x2min){
    x2max +=0.05;
    x2min -=0.05;
  }
  
  if( fabsf(fmax - fmin) < 1.e-30 || 
      fabsf((fmax - fmin)/fmax) < 1.e-6 ||
      fabsf(fmax - fmin) > 1.e+10 ){
    fprintf(stderr, "Error: fmax - fmin = %e, (fmax-fmin)/fmax = %e\n", 
	    fmax-fmin, (fmax-fmin)/fmax);
    exit(EXIT_FAILURE);
  }
  
  cpgqcir((int*)&c1, (int *)&c2);
  //  if ((nc = c2-c1+1) <0) nc=0;
  nc = c2-c1+1;
  if ( c2 < c1) nc=0;
  if (nc < 2){
    fprintf(stderr,"Not enough colors available on this device, Range=[%ld - %ld],nc=%ld, dif=%ld \n",
	    (long)c1, (long)c2, (long)nc, (long)(c2-c1) );
    exit(EXIT_FAILURE);
  }
  
  // Set the coordinate transformation matrix:  world coordinate = pixel number.	
  tr[0]=xmin0-dx*0.5;  tr[1]=dx; tr[2]=0.0;
  tr[3]=x2min0-dx2*0.5;  tr[4]=0.0; tr[5]=dx2;
  
  cpgsvp(0.2,0.8,0.2,0.8);
  cpgsch(cheight);
  cpgsci(1);
  cpgswin(xmin,xmax, x2min, x2max);
  
  if( (flag & XTICK_FORCE) == 0) 
    xtick = Tickcal((xmax - xmin)/4.);
  if( (flag & X2TICK_FORCE) == 0) 
    x2tick = Tickcal((x2max - x2min)/4.);
  
  cpgbox("BCNTS",xtick , 2, "BCNTSV",x2tick,2);
  if(strlen(title)>0) cpgmtxt("T", lbl_pos[0][0], lbl_pos[0][1], lbl_pos[0][2], title); 
  if(strlen(xlabel)>0) cpgmtxt("B", lbl_pos[1][0], lbl_pos[1][1], lbl_pos[1][2], xlabel); 
  if(strlen(ylabel)>0) cpgmtxt("L", lbl_pos[2][0], lbl_pos[2][1], lbl_pos[2][2], ylabel); 
  cpgsitf(0); // Linear
  Palette(); /* Rainbow */
  cpgimag(farr, nx, ny, 1, nx, 1, ny, fmin, fmax, tr);
  cpgsch(cheight+1);
  Palette(); /* Rainbow */
  
  cpgwedg("RI", 1, 2, fmin, fmax, "");
}


void Plt_inf::Palette(void) {
  /* int	type;
   float	bright, contra; */
  
  float	gl[2] = {0.0, 1.0}, gr[2] = {0.0, 1.0}, gg[2] = {0.0, 1.0}; 
  float gb[2] = {0.0, 1.0}, rl[9] = {-0.5, 0.0, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.7};
  float rr[9] = { 0.0, 0.0, 0.0,  0.0,  0.6,  1.0,  1.0,  1.0, 1.0};
  float rg[9] = { 0.0, 0.0, 0.0,  1.0,  1.0,  1.0,  0.6,  0.0, 1.0};
  float rb[9] = { 0.0, 0.3,  0.8,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0}; 
  float  hl[5] = {0.0, 0.2, 0.4, 0.6, 1.0}, hr[5] = {0.0, 0.5, 1.0, 1.0, 1.0};
  float hg[5] = {0.0, 0.0, 0.5, 1.0, 1.0}, hb[5] = {0.0, 0.0, 0.0, 0.3, 1.0};
  float wl[10]= {0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0};
  float wr[10]= {0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0};
  float wg[10]= {0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0}; 
  float wb[10]= {0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0};
  float al[20]= {0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5,
		 0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0};
  float ar[20]= {0.0, 0.0, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0,
		 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0};
  float ag[20]= {0.0, 0.0, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8,
		 0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0}; 
  float  ab[20]= {0.0, 0.0, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9,
		  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
  int	nc;
	
  //	switch (type){
  switch (ipalet){
  case 1: /* Gray scale */
    nc=2;
    cpgctab(gl,gr,gg,gb, nc, contra, bright);
    for(int i=0; i<nc; i++) cpgscr(i+1, gr[i], gg[i], gb[i]);
    cpgscir(1,2);
    break;
  case 2: /* -- rainbow */
    nc=9;
    cpgctab(rl,rr,rg,rb, nc, contra, bright);
    for(int i=0; i<nc; i++) cpgscr(i+1, rr[i], rg[i], rb[i]);
    cpgscir(1,9);
    break;
  case 3: /*  -- heat   */
    nc=5;
    cpgctab(hl,hr,hg,hb, nc, contra, bright);
    for(int i=0; i<nc; i++) cpgscr(i+1, hr[i], hg[i], hb[i]);
    cpgscir(1,5);
    break;
  case 4: /* -- weird IRAF*/
    nc=10;
    cpgctab(wl,wr,wg,wb, nc, contra, bright);
    for(int i=0; i<nc; i++) cpgscr(i+1, wr[i], wg[i], wb[i]);
    cpgscir(1,10);
    break;
  case 5: /*  -- AIPS */
    nc=20;
    cpgctab(al,ar,ag,ab, nc, contra, bright);
    for(int i=0; i<nc; i++) cpgscr(i+1, ar[i], ag[i], ab[i]);
    cpgscir(1,20);
    break;
  default : 
    fprintf(stderr, " Palette type is wrong: type= %d \n", ipalet);
    exit(EXIT_FAILURE);
  }
}


/**********************************************
   Fringe Complex 2D array plotting 
*********************************************/
int Plt_inf::C2dplot(const float* xarr, const float* yarr, 
		     const FComplex *carr, long nx, long ny)
{
  float   frange;
  long    ixmax=0, iymax=0, nplt;
  float   xmax, xmin, ymin, ymax;
  Maxmin_db <float> maxmin_db;
  
  float dx = xarr[1] - xarr[0];
  float dy = yarr[1] - yarr[0];
  nplt = nx > ny ? nx : ny;
  std::vector <float> farr(nx*ny);
  std::vector <float> amp[3];  
  std::vector <float> phs[3];

  for(int i=0; i<nx*ny; i++) farr[i] = carr[i].Amp();
  maxmin_db.Max_min2(&farr[0], nx, ny);
  ixmax = maxmin_db.Imax();
  iymax = maxmin_db.Jmax();
  fmax = maxmin_db.Max();
  fmin = maxmin_db.Min();


  //  const FComplex *cp1 = carr + iymax * nx;

  /* Computing Ampltidue and Phase of the carray */
  if( (flag & PLOT_COLMN) == PLOT_COLMN){
    for(int i=0; i<3; i++){
      amp[i].resize(ny);
      phs[i].resize(ny);
    }
    for(int i=0; i<ny; i++){
      if( ixmax != 0){
	amp[0][i] = carr[ixmax-1 + nx*i].Amp();
	phs[0][i] = carr[ixmax-1 + nx*i].Phase();
      }
      amp[1][i] = carr[ixmax + nx*i].Amp();
      phs[1][i] = carr[ixmax + nx*i].Phase();
      if(ixmax != nx-1){
	amp[2][i] = carr[ixmax+1 + nx*i].Amp();
	phs[2][i] = carr[ixmax+1 + nx*i].Phase();
      }
    }
    nplt = ny;
  }else{
    for(int i=0; i<3; i++){
      amp[i].resize(nx);
      phs[i].resize(nx);
    }
    for(int i=0; i<nx; i++){
      if( iymax !=0){
	amp[0][i] = carr[i + nx*(iymax-1)].Amp();
	phs[0][i] = carr[i + nx*(iymax-1)].Phase();
      }
      amp[1][i] = carr[i + nx*iymax].Amp();
      phs[1][i] = carr[i + nx*iymax].Phase();
      if( iymax != ny-1){
	amp[2][i] = carr[i + nx*(iymax+1)].Amp();
	phs[2][i] = carr[i + nx*(iymax+1)].Phase();
      }
    }
    nplt = nx;
  }

  maxmin_db.Max_min1(xarr, nx);
  xmax = maxmin_db.Max();
  xmin = maxmin_db.Min();
  if( (flag & XMAX_FORCE) == XMAX_FORCE)
    xmax = this->xmax;
  if( (flag & XMIN_FORCE) == XMIN_FORCE)
    xmin = this->xmin;

  maxmin_db.Max_min1(yarr,ny);
  ymax = maxmin_db.Max();
  ymin = maxmin_db.Min();
  if( (flag & YMAX_FORCE) == YMAX_FORCE)
    ymax = this->ymax;
  if( (flag & YMIN_FORCE) == YMIN_FORCE)
    ymin = this->ymin;
  
  if( fabsf(fmax-  fmin) < 1.e-30){
    fprintf(stderr, "Error: fmax - fmin < 1.e-30\n");
    return(-1);
  }
  if( fabsf(ymax-  ymin) < 1.e-30){
    fprintf(stderr, "Error: ymax - ymin (%11.4e)< 1.e-30\n", ymin);
    return(-1);
  }
  if( fabsf(xmax-  xmin) < 1.e-30){
    fprintf(stderr, "Error: xmax - xmin (%11.4e)< 1.e-30\n", xmin);
    return(-1);
  }

  cpgbbuf();
  if( flag_nextpage==0){ // if flag==1, rely on caller's control 
    cpgsubp(1,3); 
    cpgpanl(1,1);
  }
  cpgsch(3.5);
  int32_t c1, c2, nc;
  cpgqcir((int*)&c1, (int *)&c2);
  nc = c2 - c1 + 1;
  if ( c2 < c1) nc=0;
  //  printf("Number of color indices used for image: %d\n",nc); 
  if (nc < 2){
    fprintf(stderr,"Not enough colors available on this device. range=[%ld - %ld],nc=%ld dif=%ld\n",
	    (long)c1,(long)c2,(long)nc,(long)(c2-c1) );
    exit(EXIT_FAILURE);
  }
  
  /* Set the coordinate transformation matrix:
     world coordinate = pixel number.	*/
  float tr[6];
  tr[0]=xmin-dx;  tr[1]=dx; tr[2]=0.0;
  tr[3]=ymin-dy;  tr[4]=0.0; tr[5]=dy;
  
  cpgsvp(0.2,0.8,0.2,0.8);
  cpgsch(2.0);
  cpgsci(1);
  cpgswin(xmin,xmax, ymin, ymax);
  
  if((flag & XTICK_FORCE) ==0) 
    xtick = Tickcal((xmax - xmin)/4.);
  if((flag & YTICK_FORCE) ==0) 
    ytick = Tickcal((ymax - ymin)/4.);
  
  char xopt[80], yopt[80];
  if( (flag2 & XOPT_FORCE) == XOPT_FORCE)
    strcpy(xopt, this->xopt);
  else{
    strcpy(xopt,"BCNTS");
    strcat(xopt, this->xopt);
  }
  if( (flag2 & YOPT_FORCE) == YOPT_FORCE)
    strcpy(yopt, this->yopt);
  else{
    strcpy(yopt,"BCNTS");
    strcat(yopt, this->yopt);
  }
  cpgbox(xopt,xtick, 2, yopt,ytick,2);
  cpgsch(3.0);
  cpgmtxt("T", 1.0, 0.5, 0.5, title); 
  cpgmtxt("L", 2.5, 0.5, 0.5, ylabel); 
  cpgmtxt("B", 2.0, 0.5, 0.5, xlabel); 
  //  Palette(2);  // Rainbow 
  Palette();  // Rainbow 
  cpgimag(&farr[0], nx, ny, 1, nx, 1, ny, fmin, fmax, tr);

  if( (flag2 & DRAW_MAXLINE) == DRAW_MAXLINE){
    float xln[2], yln[2];
    xln[0] = xmin; xln[1] = xmax;
    yln[0] = yln[1] = ymin + dy*iymax; 
    cpgline(2,xln, yln);
    xln[0] = xln[1] = xmin + dx*ixmax;
    yln[0] = ymin; yln[1] = ymax;
    cpgline(2,xln, yln);
  }

  //+++++++++++++++++++++++++++++++++++++++
  if( flag_nextpage ==0) cpgpanl(1,2);
  else{
    cpgask(0); cpgpage(); 
  };
  cpgsci(1);
  fmin=0.;
  frange= fmax- fmin;
  fmax += frange*0.1; fmin -= frange*0.1;
  cpgsvp(0.2,0.8,0.2,0.8);
  cpgsch(2.0);
  float ftick= Tickcal(frange/4.);
  if( (flag & PLOT_COLMN) == PLOT_COLMN){
    cpgswin(ymin,ymax, fmin,fmax);
    cpgbox(xopt, ytick, 2, yopt,ftick,2);
  }else{
    cpgswin(xmin,xmax, fmin,fmax);
    cpgbox(xopt, xtick, 2, yopt,ftick,2);
  }
  cpgsch(3.0);
  cpgmtxt("T", 1.0, 0.5, 0.5 , title); 
  cpgmtxt("L", 3.5, 0.5, 0.5, "\\frAmplitude"); 
  if( (flag & PLOT_COLMN) == PLOT_COLMN)
    cpgmtxt("B", 2.0, 0.5, 0.5, ylabel); 
  else
    cpgmtxt("B", 2.0, 0.5, 0.5, xlabel); 
  for(int i=0; i<3; i++){
    switch (i){
    case 0:
      cpgsci(2); 
      if(ixmax == 0 || iymax == 0 
	 || (flag2 & SIDE_PLOT) ==0) continue;
      break;
    case 1:
      cpgsci(1); break;
    case 2:
      if(ixmax == nx-1 || iymax == ny-1
	 || (flag2 & SIDE_PLOT) == 0) continue;
      cpgsci(3); break;
    }
    if( (flag & PLOT_COLMN) == PLOT_COLMN){
      if( ny > 10) cpgpt(ny, yarr, &amp[i][0], 2);
      else      cpgline(ny, yarr, &amp[i][0]);
    }else{
      if( (flag & PLOT_MODE) == 0)
	cpgline(nx, xarr, &amp[i][0]);
      else
	if(nx > 10) cpgpt(nx, xarr, &amp[i][0], 2);
	else  cpgline(nx, xarr, &amp[i][0]);
    }
  }

  //+++++++++++++++++++++++++++++++++++++++
  if( flag_nextpage ==0) cpgpanl(1,3);
  else{
    cpgpage(); cpgask(1);
  };
  
  cpgsci(1);
  maxmin_db.Max_min1(&phs[1][0], nplt);
  
  float pmax, pmin;
  if((flag & PMAX_FORCE) == PMAX_FORCE) pmax = this->pmax;
  else     pmax = maxmin_db.Max();
  if((flag & PMIN_FORCE) == PMIN_FORCE) pmin = this->pmin;
  else     pmin = maxmin_db.Min();
  frange = pmax - pmin;
  pmax += frange*0.1;
  pmin -= frange*0.1;
  cpgsvp(0.2,0.8,0.2,0.8);
  cpgsch(2.0);
  float ptick = Tickcal((pmax - pmin)/4.);    
  if( (flag & PLOT_COLMN) == PLOT_COLMN){
    cpgswin(ymin,ymax, pmin,pmax);
    cpgbox(xopt,ytick , 2, yopt,ptick,2);
  }else{
    cpgswin(xmin,xmax,pmin,pmax);
    cpgbox(xopt,xtick , 2, yopt,ptick,2);
  }
  cpgsch(3.0);
  cpgmtxt("T", 1.0, 0.5, 0.5, title); 
  cpgmtxt("L", 3.0, 0.5, 0.5, "\\frPhase (radian)"); 

  if( (flag & PLOT_COLMN) == PLOT_COLMN)
    cpgmtxt("B", 2.0, 0.5, 0.5, ylabel); 
  else
    cpgmtxt("B", 2.0, 0.5, 0.5, xlabel); 

  for(int i=0; i<3; i++){
    switch (i){
    case 0:
      cpgsci(2); 
      if(ixmax == 0 || iymax == 0 
	 || (flag2 & SIDE_PLOT) ==0) continue;
      break;
    case 1:
      cpgsci(1); break;
    case 2:
      if(ixmax == nx-1 || iymax == ny-1
	 || (flag2 & SIDE_PLOT) ==0 ) continue;
      cpgsci(3); break;
    }

    if( (flag & PLOT_COLMN) == PLOT_COLMN){
      if( ny > 10) cpgpt(ny, yarr, &phs[i][0], 2);
      else         cpgline(ny, yarr, &phs[i][0]);
    }else{
      if( nx > 10) cpgpt(nx, xarr, &phs[i][0], 2);
      else    cpgline(nx, xarr, &phs[i][0]);
    }
  }

  cpgebuf();    
  if( flag & DEVICE_SET)      cpgclos();
  return 0;
}



